Index: main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/applicant.py
===================================================================
--- main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/applicant.py	(revision 17086)
+++ main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/applicant.py	(revision 17091)
@@ -23,9 +23,9 @@
 from kofacustom.nigeria.applicants.applicant import NigeriaApplicant
 from kofacustom.lpng.applicants.interfaces import(
-    ICustomApplicant, ICustomApplicantEdit)
+    ICustomApplicant, ICustomApplicantEdit, IPollingUnit)
 
 class CustomApplicant(NigeriaApplicant):
 
-    grok.implements(ICustomApplicant, ICustomApplicantEdit)
+    grok.implements(ICustomApplicant, ICustomApplicantEdit, IPollingUnit)
     grok.provides(ICustomApplicant)
 
Index: main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser.py
===================================================================
--- main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser.py	(revision 17086)
+++ main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser.py	(revision 17091)
@@ -26,4 +26,5 @@
     FriendlyDatetimeDisplayWidget)
 from waeup.kofa.applicants.pdf import PDFApplicationSlip
+from waeup.kofa.browser.layout import KofaEditFormPage, action
 from waeup.kofa.applicants.browser import (
     ApplicantRegistrationPage, ApplicantsContainerPage,
@@ -46,4 +47,6 @@
     ICustomApplicantOnlinePayment,
     ICustomApplicantEdit,
+    IPollingUnit,
+    STATES, LGAS, WARDS, PUNITS
     )
 from kofacustom.lpng.interfaces import MessageFactory as _
@@ -55,8 +58,21 @@
 
     @property
-    def form_fields(self):
-        form_fields = grok.AutoFields(ICustomApplicant)
+    def render_punit(self):
+        if self.context.punit:
+            punit = self.context.punit.split('_')
+            return ' / '.join([STATES[punit[0]], 
+                    LGAS['_'.join(punit[:2])], 
+                    WARDS['_'.join(punit[:3])] , 
+                    PUNITS['_'.join(punit[:4])]
+                   ])
+        return
+
+    @property
+    def form_fields(self):
+        form_fields = grok.AutoFields(
+            ICustomApplicant).omit('locked', 'suspended', 'federalstate', 
+                                   'lga', 'ward', 'punit')
         form_fields['perm_address'].custom_widget = BytesDisplayWidget
-        form_fields['notice'].custom_widget = BytesDisplayWidget
+        #form_fields['notice'].custom_widget = BytesDisplayWidget
         if not getattr(self.context, 'student_id'):
             form_fields = form_fields.omit('student_id')
@@ -91,5 +107,6 @@
     @property
     def form_fields(self):
-        form_fields = grok.AutoFields(ICustomApplicant)
+        form_fields = grok.AutoFields(ICustomApplicant).omit( 
+            'federalstate', 'lga', 'ward', 'punit')
         if not getattr(self.context, 'student_id'):
             form_fields = form_fields.omit('student_id')
@@ -136,5 +153,6 @@
     def form_fields(self):
         form_fields = grok.AutoFields(ICustomApplicantEdit)
-        form_fields = form_fields.omit('notice', 'locked', 'suspended')
+        form_fields = form_fields.omit('locked', 'suspended', 'federalstate', 
+                                       'lga', 'ward', 'punit')
         if not getattr(self.context, 'student_id'):
             form_fields = form_fields.omit('student_id')
@@ -177,2 +195,39 @@
             self.context.__parent__, applicantview, note=self.note,
             omit_fields=())
+
+class PunitFormPage(KofaEditFormPage):
+    """
+    """
+    grok.context(ICustomApplicant)
+    grok.require('waeup.handleApplication')
+    grok.name('punitformpage')
+    form_fields = grok.AutoFields(IPollingUnit)
+    grok.template('puniteditpage')
+    label = _('Locate polling unit')
+    pnav = 3
+
+    @action(_('Save'), style='primary')
+    def save(self, **data):
+        changed_fields = self.applyData(self.context, **data)
+        # Turn list of lists into single list
+        if changed_fields:
+            changed_fields = reduce(lambda x, y: x+y, changed_fields.values())
+        if 'federalstate' in changed_fields:
+            # Clear other form fields
+            self.context.lga = self.context.ward = self.context.punit = None
+            self.flash(_('Federal State has been saved.'))
+            return          
+        if 'lga' in changed_fields:
+            # Clear other form fields
+            self.context.ward = self.context.punit = None
+            self.flash(_('LGA has been saved.'))
+            return          
+        if 'ward' in changed_fields:
+            # Clear other form fields
+            self.context.punit = None
+            self.flash(_('Ward has been saved.'))
+            return
+        if 'punit' in changed_fields and self.context.punit:
+            self.flash(_('Polling Unit has been successfully saved.'))
+            self.redirect(self.url(self.context))
+        return
Index: main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser_templates/applicantdisplaypage.pt
===================================================================
--- main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser_templates/applicantdisplaypage.pt	(revision 17091)
+++ main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser_templates/applicantdisplaypage.pt	(revision 17091)
@@ -0,0 +1,81 @@
+<h2 i18n:domain="waeup.kofa" tal:condition="context/translated_state">
+  ...
+  <span tal:replace="context/translated_state">APPLICATIONSTATE
+  </span>
+  <span tal:omit-tag=""
+    i18n:translate="" tal:condition="context/suspended">(account suspended)
+  </span>
+  ...
+</h2>
+
+<div class="workflow" tal:condition="context/history">
+  <div tal:repeat="msg context/history/messages">
+    <span tal:replace="msg">MESSAGE</span><br />
+  </div>
+</div>
+
+<img tal:condition="python: context.__parent__.with_picture"
+     src="" height="180px" tal:attributes="src view/passport_url" />
+
+<table i18n:domain="waeup.kofa" class="form-table">
+  <tbody>
+    <tal:files condition="view/file_links">
+      <tr>
+        <td class="separator" colspan=2>
+          Files
+        </td>
+      </tr>
+      <tr>
+        <td colspan=2>
+          <span tal:replace="structure view/file_links" />
+        </td>
+      </tr>
+    </tal:files>
+    <tal:widgets content="structure provider:widgets" />
+    <tr>
+      <td class="fieldname" i18n:translate="">
+          Polling Unit:
+      </td>
+      <td>
+         <tal:punit replace="view/render_punit" />
+      </td>
+    </tr>
+    <tr>
+      <td class="fieldname" i18n:translate="">
+          Password:
+      </td>
+      <td>
+          <tal:password replace="view/hasPassword" />
+      </td>
+    </tr>
+  </tbody>
+</table>
+
+<tal:payments condition="view/display_payments">
+  <h3 i18n:domain="waeup.kofa" i18n:translate="">
+      Payment Tickets
+  </h3>
+  <table i18n:domain="waeup.kofa" class="table table-condensed">
+    <thead>
+      <tr>
+        <th i18n:translate="">Payment Id</th>
+        <th i18n:translate="">Creation Date</th>
+        <th i18n:translate="">Payment Date</th>
+        <th i18n:translate="">Category</th>
+        <th i18n:translate="">Item</th>
+        <th i18n:translate="">State</th>
+      </tr>
+    </thead>
+    <tbody>
+      <tr tal:repeat="value context/payments">
+        <td> <a tal:attributes="href python:view.url(value)">
+        <span tal:content="value/p_id">PID</span></a></td>
+        <td tal:content="python: layout.formatDatetime(value.creation_date)">CREATION DATE</td>
+        <td tal:content="python: layout.formatDatetime(value.payment_date)">PAYMENT DATE</td>
+        <td tal:content ="value/category">CATEGORY</td>
+        <td tal:content ="value/display_item">ITEM</td>
+        <td tal:content ="value/p_state_title">STATE</td>
+      </tr>
+    </tbody>
+  </table>
+</tal:payments>
Index: main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser_templates/puniteditpage.pt
===================================================================
--- main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser_templates/puniteditpage.pt	(revision 17091)
+++ main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/browser_templates/puniteditpage.pt	(revision 17091)
@@ -0,0 +1,32 @@
+
+<p>At a polling unit, a citizen can either register to vote or vote. 
+It is advisable to select a Polling Unit close to your area of residence 
+due to the restricted movement on election days.</p>
+
+<p>You can locate and save your polling unit by using Kofa's Polling Unit Locator Tool.</p>
+
+<p>To view your polling unit, follow the steps below:</p>
+
+<ol>
+<li>Select and save State (This is the state you would be voting in).</li>
+<li>Select and save LGA (This is the LGA in which you live).</li>
+<li>Select and save Ward.</li>
+<li>Select and save your Polling Unit.</li>
+</ol>
+<br />
+<form action="." tal:attributes="action request/URL" method="post"
+      enctype="multipart/form-data">
+
+  <table class="form-table">
+    <tbody>
+      <tal:widgets content="structure provider:widgets" />
+      <tal:files content="structure provider:files" />
+    </tbody>
+  </table>
+  <br />
+  <div tal:condition="view/availableActions">
+    <input tal:repeat="action view/actions"
+           tal:replace="structure action/render"
+           />
+  </div>
+</form>
Index: main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/interfaces.py
===================================================================
--- main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/interfaces.py	(revision 17086)
+++ main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/interfaces.py	(revision 17091)
@@ -28,7 +28,9 @@
 from waeup.kofa.schoolgrades import ResultEntryField
 from waeup.kofa.interfaces import (
-    SimpleKofaVocabulary, academic_sessions_vocab, validate_email,
+    SimpleKofaVocabulary, 
+    academic_sessions_vocab, validate_email,
     IKofaObject)
 from waeup.kofa.schema import FormattedDate, TextLineChoice, PhoneNumber
+from waeup.kofa.sourcefactory import SmartBasicContextualSourceFactory
 from waeup.kofa.students.vocabularies import (
   nats_vocab, GenderSource,RegNumberSource)
@@ -41,8 +43,8 @@
 
 def make_dict(filename, depth):
-    wards = unicodecsv.reader(
+    rows = unicodecsv.reader(
         open(os.path.dirname(__file__)  + '/%s'%filename, 'rb'))
     result = dict()
-    for row in wards:
+    for row in rows:
         result['_'.join(row[0:depth])] = row[depth]
     return result
@@ -52,5 +54,104 @@
 WARDS = make_dict('wards.csv', 3)
 PUNITS = make_dict('punits.csv', 4)
-    
+
+
+class SpecialContextualDictSourceFactoryBase(SmartBasicContextualSourceFactory):
+    """
+    """
+    def getValues(self, context):
+        sorted_items = sorted(self.DICT_NAME.items(),
+                              key=lambda item: item[1])
+        return [item[0] for item in sorted_items]
+
+    def getToken(self, context, value):
+        return str(value)
+
+    def getTitle(self, context, value):
+        return self.DICT_NAME[value]
+
+
+class StateSource(SpecialContextualDictSourceFactoryBase):
+    """A source for Nigerian states, lgas, wards and polling units
+    """
+    DICT_NAME = STATES    
+
+
+class LgaSource(SpecialContextualDictSourceFactoryBase):
+    """A source for Nigerian states, lgas, wards and polling units
+    """
+    DICT_NAME = LGAS
+
+    def getValues(self, context):
+        items = []
+        if not context.federalstate:
+            return items
+        for item in self.DICT_NAME.items():
+            if item[0].split('_')[0] == context.federalstate:
+                items.append(item)
+        sorted_items = sorted(items, key=lambda item: item[1])
+        return [item[0] for item in sorted_items]
+
+
+class WardSource(SpecialContextualDictSourceFactoryBase):
+    """A source for Nigerian states, lgas, wards and polling units
+    """
+    DICT_NAME = WARDS
+
+    def getValues(self, context):
+        items = []
+        if not context.lga:
+            return items
+        for item in self.DICT_NAME.items():
+            if item[0].split('_')[:2] == context.lga.split('_')[:2]:
+                items.append(item)
+        sorted_items = sorted(items, key=lambda item: item[1])
+        return [item[0] for item in sorted_items]
+
+
+class PunitSource(SpecialContextualDictSourceFactoryBase):
+    """A source for Nigerian states, lgas, wards and polling units
+    """
+    DICT_NAME = PUNITS   
+
+    def getValues(self, context):
+        items = []
+        if not context.ward:
+            return items
+        for item in self.DICT_NAME.items():
+            if item[0].split('_')[:3] == context.ward.split('_')[:3]:
+                items.append(item)
+        sorted_items = sorted(items, key=lambda item: item[1])
+        return [item[0] for item in sorted_items]
+
+
+class IPollingUnit(IKofaObject):
+    """
+    """
+
+    federalstate = schema.Choice(
+        source = StateSource(),
+        title = _(u'State'),
+        required = False,
+        )
+
+    lga = schema.Choice(
+        source = LgaSource(),
+        title = _(u'LGA'),
+        required = False,
+        )
+
+    ward = schema.Choice(
+        source = WardSource(),
+        title = _(u'Ward'),
+        required = False,
+        )
+
+    punit = schema.Choice(
+        source = PunitSource(),
+        title = _(u'Polling Unit'),
+        required = False,
+        ) 
+
+
 class IApplicantBaseData(IKofaObject):
     """This is a base interface of an applicant with no field
@@ -71,5 +172,4 @@
     password = Attribute('Encrypted password of an applicant')
 
-
     suspended = schema.Bool(
         title = _(u'Account suspended'),
@@ -150,15 +250,4 @@
         )
                 
-    lga = schema.Choice(
-        source = LGASource(),
-        title = _(u'Local Government (Nigerians only)'),
-        required = False,
-        )
-        
-    ward = schema.ASCIILine(
-        title = _(u'Ward'),
-        required = False,
-        )
-
     phone = PhoneNumber(
         title = _(u'Phone'),
@@ -173,8 +262,8 @@
         )
 
-    notice = schema.Text(
-        title = _(u'Notice'),
-        required = False,
-        )
+    #notice = schema.Text(
+    #    title = _(u'Notice'),
+    #    required = False,
+    #    )
 
     student_id = schema.TextLine(
@@ -191,5 +280,5 @@
 
 
-class ICustomApplicant(IApplicantBaseData):
+class ICustomApplicant(IPollingUnit, IApplicantBaseData):
     """An interface for both types of applicants.
 
Index: main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/viewlets.py
===================================================================
--- main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/viewlets.py	(revision 17086)
+++ main/kofacustom.lpng/trunk/src/kofacustom/lpng/applicants/viewlets.py	(revision 17091)
@@ -18,5 +18,8 @@
 import grok
 from waeup.kofa.interfaces import IKofaObject
+from waeup.kofa.browser.viewlets import ManageActionButton
 from waeup.kofa.applicants.viewlets import ApplicantsAuthTab
+from kofacustom.lpng.applicants.interfaces import ICustomApplicant
+from kofacustom.lpng.applicants.browser import ApplicantDisplayFormPage
 
 from kofacustom.lpng.interfaces import MessageFactory as _
@@ -35,2 +38,11 @@
     def link_target(self):
         return
+
+class SelectPunitActionButton(ManageActionButton):
+    grok.order(1)
+    grok.context(ICustomApplicant)
+    grok.require('waeup.handleApplication')
+    grok.view(ApplicantDisplayFormPage)
+    icon = 'actionicon_polling.png'
+    text = _('Locate Polling Unit')
+    target ='punitformpage'
